/*
 *   khexedit - Versatile hex editor
 *   Copyright (C) 1999  Espen Sand, espensa@online.no
 *
 *   The contents of this file is derived from kfontchooser.h of
 *   the KDE (1.x) libraries by Mark Donohoe and Stephan Kulow.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _FONT_CHOOSER_H_
#define _FONT_CHOOSER_H_

#include <qcheckbox.h> 
#include <qcombobox.h>
#include <qfont.h>
#include <qlabel.h>
#include <qspinbox.h>
#include <qwidget.h>

class CFontChooser : public QWidget
{
  Q_OBJECT
	
  public:
    CFontChooser( QWidget *parent = 0, const char *name = 0 );
    ~CFontChooser() {};

    void setFont( QFont start_fnt, bool fixed = false );
    const QFont &font( void );

  signals:
    void fontChanged( QFont font );

  public slots:
    virtual void setEnabled( bool );

  protected slots:
    void slotSelectFont( const QString & );
    void slotCharset( const QString & );	
    void slotFontSize( int );
    void slotFontBold( bool );
    void slotFontItalic( bool );

  protected:
    void fillCharsetCombo();
    void getFontList( QStringList &list, bool fixed = false );
    void getFontList( QStringList &list, const char *pattern );
    void addFont( QStringList &list, const char *xfont );
	
  protected:
    QFont mFont;

    QLabel    *mTypeFaceLabel;
    QLabel    *mSizeLabel;
    QLabel    *mCharSetLabel;
    QSpinBox  *mSizeSpin;
    QComboBox *mTypeFaceCombo;
    QComboBox *mCharsetCombo;
    QCheckBox *mBoldCheck; 
    QCheckBox *mItalicCheck;

    QStringList mFontList;
    QStringList mFixedList;
};

#endif
